---
title: Sync Payment Preprocessing
slug: apis/payments/cos-card-payments/sync-payment-apis/sync-preprocessing
description: Explore our comprehensive guide on the API endpoint for payment processing, detailing required and optional parameters, statuses, and transaction identifiers for seamless integration.
icon: {"apiMethod":"POST"}
docTags: 
createdAt: 2024-08-14T07:39:58.503Z
---

## API reference

Send a push or pull preprocessing sync payment

:::ApiMethodV2
```json
{
  "name": "Endpoint: v1/syncpayments/preprocessing",
  "method": "POST",
  "url": "https://sandbox.crbcos.com/cardpayments/v1/syncpayments/preprocessing",
  "description": "",
  "tab": "examples",
  "examples": {
    "languages": [
      {
        "id": "m2Ue7Qz6dVWcDZ36gKpPo",
        "language": "curl",
        "code": "curl --location 'https://sandbox.crbcos.com/v1/syncpayments/preprocessing' \\\n--header 'Content-Type: application/json' \\\n--header 'Accept: application/json' \\\n--data '{\n  \"productId\": \"29f3022a-ccfc-42eb-aa8f-b29500f13d00\",\n  \"accountNumber\": \"7279550514\",\n  \"amount\": 421,\n  \"paymentType\": \"Push\",\n  \"cardId\": \"11FB445C487140A9BEA51457A796172A000000\",\n  \"cardToken\": \"string\",\n  \"businessType\": \"WalletTransfer\"\n}'",
        "customLabel": ""
      },
      {
        "id": "VeeGmwkA_clEzxjzmMBUK",
        "language": "nodejs",
        "code": "var https = require('follow-redirects').https;\nvar fs = require('fs');\n\nvar options = {\n  'method': 'POST',\n  'hostname': 'sandbox.crbcos.com',\n  'path': '/v1/syncpayments/preprocessing',\n  'headers': {\n    'Content-Type': 'application/json',\n    'Accept': 'application/json'\n  },\n  'maxRedirects': 20\n};\n\nvar req = https.request(options, function (res) {\n  var chunks = [];\n\n  res.on(\"data\", function (chunk) {\n    chunks.push(chunk);\n  });\n\n  res.on(\"end\", function (chunk) {\n    var body = Buffer.concat(chunks);\n    console.log(body.toString());\n  });\n\n  res.on(\"error\", function (error) {\n    console.error(error);\n  });\n});\n\nvar postData = JSON.stringify({\n  \"productId\": \"29f3022a-ccfc-42eb-aa8f-b29500f13d00\",\n  \"accountNumber\": \"7279550514\",\n  \"amount\": 421,\n  \"paymentType\": \"Push\",\n  \"cardId\": \"11FB445C487140A9BEA51457A796172A000000\",\n  \"cardToken\": \"string\",\n  \"businessType\": \"WalletTransfer\"\n});\n\nreq.write(postData);\n\nreq.end();",
        "customLabel": ""
      },
      {
        "id": "BP-IjxQK-9xJ_YCWNyGNx",
        "language": "python",
        "code": "import requests\nimport json\n\nurl = \"https://sandbox.crbcos.com/v1/syncpayments/preprocessing\"\n\npayload = json.dumps({\n  \"productId\": \"29f3022a-ccfc-42eb-aa8f-b29500f13d00\",\n  \"accountNumber\": \"7279550514\",\n  \"amount\": 421,\n  \"paymentType\": \"Push\",\n  \"cardId\": \"11FB445C487140A9BEA51457A796172A000000\",\n  \"cardToken\": \"string\",\n  \"businessType\": \"WalletTransfer\"\n})\nheaders = {\n  'Content-Type': 'application/json',\n  'Accept': 'application/json'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n",
        "customLabel": ""
      },
      {
        "id": "xu3xbbWT_a-_Y7mcgL0S3",
        "language": "ruby",
        "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://sandbox.crbcos.com/v1/syncpayments/preprocessing\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"Content-Type\"] = \"application/json\"\nrequest[\"Accept\"] = \"application/json\"\nrequest.body = JSON.dump({\n  \"productId\": \"29f3022a-ccfc-42eb-aa8f-b29500f13d00\",\n  \"accountNumber\": \"7279550514\",\n  \"amount\": 421,\n  \"paymentType\": \"Push\",\n  \"cardId\": \"11FB445C487140A9BEA51457A796172A000000\",\n  \"cardToken\": \"string\",\n  \"businessType\": \"WalletTransfer\"\n})\n\nresponse = https.request(request)\nputs response.read_body\n",
        "customLabel": ""
      },
      {
        "id": "yes-XNvEAr36pmLaxLh_p",
        "language": "go",
        "code": "package main\n\nimport (\n  \"fmt\"\n  \"strings\"\n  \"net/http\"\n  \"io\"\n)\n\nfunc main() {\n\n  url := \"https://sandbox.crbcos.com/v1/syncpayments/preprocessing\"\n  method := \"POST\"\n\n  payload := strings.NewReader(`{\n  \"productId\": \"29f3022a-ccfc-42eb-aa8f-b29500f13d00\",\n  \"accountNumber\": \"7279550514\",\n  \"amount\": 421,\n  \"paymentType\": \"Push\",\n  \"cardId\": \"11FB445C487140A9BEA51457A796172A000000\",\n  \"cardToken\": \"string\",\n  \"businessType\": \"WalletTransfer\"\n}`)\n\n  client := &http.Client {\n  }\n  req, err := http.NewRequest(method, url, payload)\n\n  if err != nil {\n    fmt.Println(err)\n    return\n  }\n  req.Header.Add(\"Content-Type\", \"application/json\")\n  req.Header.Add(\"Accept\", \"application/json\")\n\n  res, err := client.Do(req)\n  if err != nil {\n    fmt.Println(err)\n    return\n  }\n  defer res.Body.Close()\n\n  body, err := io.ReadAll(res.Body)\n  if err != nil {\n    fmt.Println(err)\n    return\n  }\n  fmt.Println(string(body))\n}",
        "customLabel": ""
      }
    ],
    "selectedLanguageId": "m2Ue7Qz6dVWcDZ36gKpPo"
  },
  "results": {
    "languages": [
      {
        "id": "qaLRHBp_njcq9NhtL7R3X",
        "language": "200",
        "code": "",
        "customLabel": ""
      }
    ],
    "selectedLanguageId": "qaLRHBp_njcq9NhtL7R3X"
  },
  "request": {
    "pathParameters": [],
    "queryParameters": [],
    "headerParameters": [],
    "bodyDataParameters": [
      {
        "name": "cardId",
        "kind": "optional",
        "type": "string",
        "description": "The identifier for the card token, as defined in COS. ",
        "": "The identifier for the card token, as defined in COS. "
      },
      {
        "name": "cardToken",
        "kind": "optional",
        "type": "string",
        "description": "A randomly generated string of characters that relates to the consumer's payment card (15-38 alphanumeric characters).",
        "": "A randomly generated string of characters that relates to the consumer's payment card (15-38 alphanumeric characters)."
      },
      {
        "name": "accountNumber",
        "kind": "required",
        "type": "string",
        "description": "The identifier for the account, as defined in COS. ",
        "": "The identifier for the account, as defined in COS. "
      },
      {
        "name": "amount",
        "kind": "required",
        "type": "Integer",
        "description": "The amount to be transferred, in cents. For example, 10001 = $100.01.",
        "children": []
      },
      {
        "name": "paymentType",
        "kind": "required",
        "type": "string",
        "description": "The type of payment. Value is either \"Push\" or \"Pull\"",
        "": "required"
      },
      {
        "name": "correspondingEntity",
        "kind": "optional",
        "type": "object",
        "description": "",
        "": "object",
        "children": [
          {
            "name": "firstName",
            "kind": "required",
            "type": "string",
            "description": "First name. Min 1 character, max 35 characters"
          },
          {
            "name": "lastName",
            "kind": "required",
            "type": "string",
            "description": "Last name. Min 1 character, max 35 characters"
          },
          {
            "name": "externalAccountIdentifier",
            "kind": "required",
            "type": "string",
            "description": "Account number to ensure the money movement is routed to the correct destination."
          },
          {
            "name": "address",
            "kind": "optional",
            "type": "object",
            "description": "Address of card holder",
            "children": [
              {
                "name": "street1",
                "kind": "required",
                "type": "string",
                "description": "Street address line 1. Max length 60"
              },
              {
                "name": "street2",
                "kind": "optional",
                "type": "string",
                "description": "Street address line 2. Max length 60"
              },
              {
                "name": "city",
                "kind": "required",
                "type": "string",
                "description": "Name of the city. Max length 60"
              },
              {
                "name": "state",
                "kind": "optional",
                "type": "string",
                "description": "State code. 2 characters"
              },
              {
                "name": "postalCode",
                "kind": "required",
                "type": "string",
                "description": "Max 10 characters"
              },
              {
                "name": "countryCode",
                "kind": "required",
                "type": "string",
                "description": "2-letter ISO country code"
              }
            ]
          }
        ],
        "schema": [
          {
            "name": "firstName",
            "kind": "required",
            "type": "string",
            "description": "First name. Min 1 character, max 35 characters"
          },
          {
            "name": "lastName",
            "kind": "required",
            "type": "string",
            "description": "Last name. Min 1 character, max 35 characters"
          },
          {
            "name": "externalAccountIdentifier",
            "kind": "required",
            "type": "string",
            "description": "Account number to ensure the money movement is routed to the correct destination."
          },
          {
            "name": "address",
            "kind": "optional",
            "type": "object",
            "description": "Address of card holder",
            "children": [
              {
                "name": "street1",
                "kind": "required",
                "type": "string",
                "description": "Street address line 1. Max length 60"
              },
              {
                "name": "street2",
                "kind": "optional",
                "type": "string",
                "description": "Street address line 2. Max length 60"
              },
              {
                "name": "city",
                "kind": "required",
                "type": "string",
                "description": "Name of the city. Max length 60"
              },
              {
                "name": "state",
                "kind": "optional",
                "type": "string",
                "description": "State code. 2 characters"
              },
              {
                "name": "postalCode",
                "kind": "required",
                "type": "string",
                "description": "Max 10 characters"
              },
              {
                "name": "countryCode",
                "kind": "required",
                "type": "string",
                "description": "2-letter ISO country code"
              }
            ]
          }
        ]
      },
      {
        "name": "mcc",
        "kind": "optional",
        "type": "string",
        "description": "Merchant Category Code (MCC). 4-digits that a credit card issuer uses to categorize consumer transactions for their card.",
        "": "Merchant Category Code (MCC). 4-digits that a credit card issuer uses to categorize consumer transactions for their card."
      },
      {
        "name": "initiatorName",
        "kind": "optional",
        "type": "string",
        "description": "Per-payment merchant/sender name override for the cardholder's bank statement. Max 17 chars",
        "": "initiatorName"
      },
      {
        "name": "clientIdentifier",
        "kind": "optional",
        "type": "string",
        "description": "A string that identifies the client associated with the payment.",
        "": "A string that identifies the client associated with the payment."
      },
      {
        "name": "businessType",
        "kind": "optional",
        "type": "string",
        "description": "Business Application Indicator (BAI) -- a standardized category used to classify the nature of a business.\nOne of \nBB - 'Business2Business', \nFD - 'Funds Disbursement ', \nAA - 'Account2Account', \nPP - 'Person2Person', \nMT -'Money Transfer', \nCD - 'Cash Deposit', \nFT - 'Funds Transfer', \nWT - 'Wallet Transfer', \nCP - 'Card Bill Payment'\nMD - 'Merchant Disbursement'",
        "": "Business Application Indicator (BAI) -- a standardized category used to classify the nature of a business.\nOne of \nBB - 'Business2Business', \nFD - 'Funds Disbursement ', \nAA - 'Account2Account', \nPP - 'Person2Person', \nMT -'Money Transfer', \nCD - 'Cash Deposit', \nFT - 'Funds Transfer', \nWT - 'Wallet Transfer', \nCP - 'Card Bill Payment'\nMD - 'Merchant Disbursement'"
      },
      {
        "name": "purposeOfPayment",
        "kind": "optional",
        "type": "string",
        "description": "The reason for the transaction. e.g. payroll. Needed for international. ",
        "": "The reason for the transaction. e.g. payroll. Needed for international. "
      }
    ],
    "formDataParameters": []
  },
  "currentNewParameter": {
    "label": "Body Parameter",
    "value": "bodyDataParameters"
  },
  "response": [
    {
      "name": "id",
      "kind": "optional",
      "type": "string",
      "description": "The GUID of the payment you want to retrieve",
      "children": []
    },
    {
      "name": "originalPaymentId",
      "kind": "optional",
      "type": "string",
      "description": " A UUID that is the primary identifier for the payment.",
      "children": []
    },
    {
      "name": "clientIdentifier",
      "kind": "optional",
      "type": "string",
      "description": " A string that identifies the client associated with the payment.",
      "children": []
    },
    {
      "name": "amount",
      "kind": "optional",
      "type": "integer",
      "description": "The amount to be transferred, in cents. For example, 10001 = $100.01.",
      "children": []
    },
    {
      "name": "paymentType",
      "kind": "optional",
      "type": "string",
      "description": "Indicates the direction of the payment:\nPush -  Money sent out (e.g. disbursement to a customer)\nPull -  Money received (e.g. a charge to a customer's card)",
      "children": []
    },
    {
      "name": "status",
      "kind": "optional",
      "type": "string",
      "description": "One of  \"Created\",\n                        \"Pending\",\n                        \"Authorized\",\n                        \"Submitted\",\n                        \"Processing\",\n                        \"Completed\",\n                        \"Rejected\",\n                        \"Failed\"",
      "children": []
    },
    {
      "name": "source",
      "kind": "optional",
      "type": "string",
      "description": "How the payment was initiated e.g. API ",
      "children": []
    },
    {
      "name": "productId",
      "kind": "optional",
      "type": "string",
      "description": " A UUID that identifies the product, as defined in COS.",
      "children": []
    },
    {
      "name": "partnerId",
      "kind": "optional",
      "type": "string",
      "description": " A UUID that identifies the partner, as defined in COS.",
      "children": []
    },
    {
      "name": "cardId",
      "kind": "optional",
      "type": "string",
      "description": " A UUID that identifies the card used.",
      "children": []
    },
    {
      "name": "cardToken",
      "kind": "optional",
      "type": "string",
      "description": "A randomly generated string of characters that relates to the consumer's payment card (15-38 alphanumeric characters)",
      "children": []
    },
    {
      "name": "network",
      "kind": "optional",
      "type": "string",
      "description": "The network through which the payment is processed (e.g. Visa, Mastercard).",
      "children": []
    },
    {
      "name": "cardBrand",
      "kind": "optional",
      "type": "string",
      "description": "One of  \"AmericanExpress\",\n                        \"ChinaUnionPay\",\n                        \"Dankort\",\n                        \"DinersClub\",\n                        \"Discover\",\n                        \"Hipercard\",\n                        \"JCB\",\n                        \"Laser\",\n                        \"Maestro\",\n                        \"MasterCard\",\n                        \"RuPay\",\n                        \"Solo\",\n                        \"Switch\",\n                        \"Visa\",\n                        \"Unknown\"",
      "children": []
    },
    {
      "name": "panLastFour",
      "kind": "optional",
      "type": "string",
      "description": "The last four digits of the Primary Account Number (card number).",
      "children": []
    },
    {
      "name": "issuerCountryCode",
      "kind": "optional",
      "type": "string",
      "description": "A string representing the country code of the card issuer.",
      "children": []
    },
    {
      "name": "retrievalReferenceId",
      "kind": "optional",
      "type": "string",
      "description": "A unique identifier used for retrieving transaction details, often used in disputes or reconciliation.",
      "children": []
    },
    {
      "name": "reasonCode",
      "kind": "optional",
      "type": "string",
      "description": "A 2-digit code signifying the transaction result (approved or decline). For example, 00 means successful.",
      "children": []
    },
    {
      "name": "reasonDescription",
      "kind": "optional",
      "type": "string",
      "description": "A string describing the transaction result. For example, Approved.",
      "children": []
    },
    {
      "name": "traceNumber",
      "kind": "optional",
      "type": "string",
      "description": "A unique number assigned to a transaction from the time it leaves the merchant bank until it arrives at the cardholder bank",
      "children": []
    },
    {
      "name": "correspondingEntity",
      "kind": "optional",
      "type": "object",
      "description": "References information about who initiated the transaction, linking to an OriginatorInfo object.",
      "children": [
        {
          "name": "firstName",
          "kind": "optional",
          "type": "string",
          "description": "First name. Min 1 character, max 35 characters"
        },
        {
          "name": "lastName",
          "kind": "optional",
          "type": "string",
          "description": "Last name. Min 1 character, max 35 characters"
        },
        {
          "name": "externalAccountIdentifier",
          "kind": "optional",
          "type": "string",
          "description": ""
        },
        {
          "name": "address",
          "kind": "optional",
          "type": "object",
          "description": "Address of card holder",
          "children": [
            {
              "name": "street1",
              "kind": "optional",
              "type": "string",
              "description": "Address of card holder - Street address line 1. Max length 60"
            },
            {
              "name": "street2",
              "kind": "optional",
              "type": "string",
              "description": "Address of card holder - Street address line 2. Max length 60"
            },
            {
              "name": "city",
              "kind": "optional",
              "type": "string",
              "description": "Address of card holder - City full name. 50 character maximum"
            },
            {
              "name": "state",
              "kind": "optional",
              "type": "string",
              "description": "State code. 2 characters"
            },
            {
              "name": "postalCode",
              "kind": "optional",
              "type": "string",
              "description": "Address of card holder - Max 10 characters"
            },
            {
              "name": "countryCode",
              "kind": "optional",
              "type": "string",
              "description": "2-letter ISO country code"
            }
          ]
        }
      ]
    },
    {
      "name": "mcc",
      "kind": "optional",
      "type": "string",
      "description": "Merchant Category Code (MCC). 4-digits that a credit card issuer uses to categorize consumer transactions for their card.",
      "children": []
    },
    {
      "name": "merchantVerificationValue",
      "kind": "optional",
      "type": "string",
      "description": "A value used to verify the merchant's identity.",
      "children": []
    },
    {
      "name": "initiatorName",
      "kind": "optional",
      "type": "string",
      "description": "Per-payment merchant/sender name override for the cardholder's bank statement. Max 17 chars",
      "children": []
    },
    {
      "name": "accountNumber",
      "kind": "optional",
      "type": "string",
      "description": "The account number associated with the payment.",
      "children": []
    },
    {
      "name": "businessType",
      "kind": "optional",
      "type": "string",
      "description": "Business Application Indicator (BAI) -- a standardized category used to classify the nature of a business.\nOne of \nBB - 'Business2Business', \nFD - 'Funds Disbursement ', \nAA - 'Account2Account', \nPP - 'Person2Person', \nMT -'Money Transfer', \nCD - 'Cash Deposit', \nFT - 'Funds Transfer', \nWT - 'Wallet Transfer', \nCP - 'Card Bill Payment'\nMD - 'Merchant Disbursement'",
      "children": []
    },
    {
      "name": "purposeOfPayment",
      "kind": "optional",
      "type": "string",
      "description": "The reason for the transaction. e.g. payroll. Needed for international",
      "children": []
    },
    {
      "name": "coreTransactionId",
      "kind": "optional",
      "type": "string",
      "description": "A UUID that links the payment to the core banking system.",
      "children": []
    },
    {
      "name": "memoPostId",
      "kind": "optional",
      "type": "string",
      "description": "A UUID that identifies the corresponding memo post (a temporary transaction posting).",
      "children": []
    },
    {
      "name": "memoPostRemovedAt",
      "kind": "optional",
      "type": "string",
      "description": "When the memo post was removed. I.e. When the temporary hold was released.",
      "children": []
    },
    {
      "name": "wasRefunded",
      "kind": "optional",
      "type": "boolean",
      "description": "Boolean value indicating whether the payment has been refunded.",
      "children": []
    },
    {
      "name": "refundPaymentId",
      "kind": "optional",
      "type": "string",
      "description": "A UUID that identifies the refund transaction associated with the payment.",
      "children": []
    },
    {
      "name": "createdAt",
      "kind": "optional",
      "type": "string",
      "description": "When the payment was created",
      "children": []
    },
    {
      "name": "authorizedOn",
      "kind": "optional",
      "type": "string",
      "description": "When the payment was authorized by the issuing bank.",
      "children": []
    },
    {
      "name": "submittedOn",
      "kind": "optional",
      "type": "string",
      "description": "When the payment was submitted to the network.",
      "children": []
    },
    {
      "name": "rejectedAt",
      "kind": "optional",
      "type": "string",
      "description": "When the payment was rejected.",
      "children": []
    },
    {
      "name": "completedAt",
      "kind": "optional",
      "type": "string",
      "description": "When the payment was successfully completed.",
      "children": []
    },
    {
      "name": "failedAt",
      "kind": "optional",
      "type": "string",
      "description": "When the payment failed to process.",
      "children": []
    },
    {
      "name": "limitsEligibleOn",
      "kind": "optional",
      "type": "string",
      "description": "When the transaction becomes eligible for limit calculations.",
      "children": []
    },
    {
      "name": "lastModifiedAt",
      "kind": "optional",
      "type": "string",
      "description": "When the payment record was last modified.",
      "children": []
    }
  ],
  "hasTryItOut": false,
  "autoGeneratedAnchorSlug": "endpoint-v1syncpaymentspreprocessing",
  "legacyHash": "AhHh_9ZYMt-U1G3BS7Rdj"
}
```
:::



